/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package it.tidalwave.netbeans.role.util.impl;

import javax.annotation.Nonnull;
import javax.inject.Provider;
import org.openide.util.Lookup;

/**
 *
 * @author fritz
 */
public class LookupProvider<T> implements Provider<T>
  {
    @Nonnull
    private final Class<T> clazz;

    @Nonnull
    private final Lookup lookup;

    public LookupProvider (final @Nonnull Lookup lookup, final @Nonnull Class<T> clazz)
      {
        this.lookup = lookup;
        this.clazz = clazz;
      }

    @Override
    public T get()
      {
        return lookup.lookup(clazz);
      }

    @Override @Nonnull
    public String toString()
      {
        return String.format("LookupProvider[class: %s lookup: %s]", clazz.getName(), lookup);
      }
  }
